/// <reference types="node" />
import { IncomingMessage, ServerResponse } from "http";
interface ContentSecurityPolicyDirectiveValueFunction {
    (req: IncomingMessage, res: ServerResponse): string;
}
declare type ContentSecurityPolicyDirectiveValue = string | ContentSecurityPolicyDirectiveValueFunction;
interface ContentSecurityPolicyDirectives {
    [directiveName: string]: Iterable<ContentSecurityPolicyDirectiveValue> | typeof dangerouslyDisableDefaultSrc;
}
export interface ContentSecurityPolicyOptions {
    directives?: ContentSecurityPolicyDirectives;
    reportOnly?: boolean;
}
declare const dangerouslyDisableDefaultSrc: unique symbol;
declare const getDefaultDirectives: () => {
    [x: string]: Iterable<ContentSecurityPolicyDirectiveValue> | typeof dangerouslyDisableDefaultSrc;
};
declare function contentSecurityPolicy(options?: Readonly<ContentSecurityPolicyOptions>): (req: IncomingMessage, res: ServerResponse, next: (err?: Error) => void) => void;
declare namespace contentSecurityPolicy {
    var getDefaultDirectives: () => {
        [x: string]: Iterable<ContentSecurityPolicyDirectiveValue> | unique symbol;
    };
    var dangerouslyDisableDefaultSrc: unique symbol;
}
export default contentSecurityPolicy;
export { getDefaultDirectives, dangerouslyDisableDefaultSrc };
